#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

int main(int argc, char** argv)
{
	if (argc < 2) {
		fprintf(stderr, "Usage: %s <program> [args]\n", argv[0]);
		exit(1);
	}
	char* prog_name = argv[1];
	pid_t pid;

	pid = fork();
	if (0 == pid) {
		// child
		if (-1 == execv(prog_name, argv + 1)) {
			perror("Execve");
			exit(1);
		}
		// never reached 
	} else if (pid > 0) {
		// parent
		int wstatus;
		if (-1 == wait(&wstatus)) {
			perror("Error on wait");
			exit(1);
		}
	} else {
		// error
		perror("Error on fork");
	}

	return 0;
}
