#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <errno.h>


/**
 * This function is expected to be executed by a child process. It 
 * expects the child number (e.g. 1 for the first child, 2 for the second child ...)
 * as argument.
 */ 
void print_random_numbers(int child_number)
{
	int r = rand();
	printf("Child number %d: My PID is %d - my first random number is: %d\n", child_number, getpid(), r);
	r = rand();
	printf("Child number %d: My PID is %d - my second random number is: %d\n", child_number, getpid(), r);
	r = rand();
	printf("Child number %d: My PID is %d - my third random number is: %d\n", child_number, getpid(), r);
}

int main(int argc, char** argv)
{
	srand(time(NULL));

	if (argc != 2){
		fprintf(stderr, "Usage: %s <number_of_children>\n", argv[0]);
		exit(-1);
	}
	int children = atoi(argv[1]);
		
	// TODO: Insert your code here

	printf("\n\nFinished. Press Enter to quit the program.");
	getchar();
}
