#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <string.h>

volatile int x = 0;
pthread_mutex_t mutex;


#define NUM_ITERATIONS 1000000000
#define NUM_THREADS 2


void* thread_func(void* data)
{
	for (int i = 0; i < NUM_ITERATIONS; ++i) {
		pthread_mutex_lock(&mutex);
		x++;
		pthread_mutex_unlock(&mutex);
	}
	return NULL;
}


int main (int argc, char** argv) {
	pthread_t threads[NUM_THREADS];
	int err;

	pthread_mutex_init(&mutex, NULL);

	/* Create threads */
	for (int i = 0; i < NUM_THREADS; ++i) {
		if (-1 == (err = pthread_create(&threads[i], NULL, thread_func, NULL))) {
			fprintf(stderr, "Error creating thread: %s\n", strerror(err));
			exit(1);
		}
	}

	for (int i = 0; i < NUM_THREADS; ++i)
		pthread_join(threads[i], NULL);

	pthread_mutex_destroy(&mutex);

	/* Print the final value of 'x' */
	printf ("Value of x after %i iterations by %i threads: %i\n", NUM_ITERATIONS, NUM_THREADS, x);

	return 0;
}
