#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <string.h>


volatile unsigned long  x = 0;
pthread_mutex_t mutex;

#define NUM_ITERATIONS 1000000000
#define NUM_THREADS 3


void* thread_func (void* data)
{
	pthread_mutex_lock(&mutex);
	int tmp = x;
	pthread_mutex_unlock(&mutex);	
	
	for (int i = 0; i < NUM_ITERATIONS; ++i) {
		tmp++;

	}
	pthread_mutex_lock(&mutex);
	x += tmp;
	pthread_mutex_unlock(&mutex);
	return NULL;
}


int main (int argc, char** argv) {
	pthread_t threads[NUM_THREADS];
	int err;

	pthread_mutex_init(&mutex, NULL);

	/* Create threads */
	for (int i = 0; i < NUM_THREADS; ++i) {
		if (-1 == (err = pthread_create(&threads[i], NULL, thread_func, NULL))) {
			fprintf(stderr, "Error creating thread: %s\n", strerror(err));
			exit(1);
		}
	}

	for (int i = 0; i < NUM_THREADS; ++i)
		pthread_join(threads[i], NULL);

	pthread_mutex_destroy(&mutex);

	/* Print the final value of 'x' */
	printf ("Value of x after %d iterations by %d threads: %lu\n", NUM_ITERATIONS, NUM_THREADS, x);

	return 0;
}
