/*
 * https://www.tutorialspoint.com/print-numbers-in-sequence-using-thread-synchronization-in-c-program
 * 
 * The idea is take thread count and print 1 in first thread, 
 * print 2 in second thread, print 3 in first thread etc. 
 * The output will contain numbers from 1 to 25 
 * 
 */

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int MAX = 25;
int count = 1;
pthread_mutex_t thr;
pthread_cond_t cond;
void *even(void *arg){
   while(count < MAX) {
      pthread_mutex_lock(&thr);
      if(count % 2 == 1) {
		/* block this thread until another thread signals cond. While
		blocked, the mutex is released, then re-aquired before this
		thread is woken up and the call returns. */ 
         pthread_cond_wait(&cond, &thr);
      }
      printf("%d \n", count);
      sleep(1);
      count++;
      pthread_mutex_unlock(&thr);
      pthread_cond_signal(&cond);
   }
   pthread_exit(0);
}
void *odd(void *arg){
   while(count < MAX) {
      pthread_mutex_lock(&thr);
      if(count % 2 == 0) {
         pthread_cond_wait(&cond, &thr);
      }
      printf("\t%d \n", count);
      sleep(1);
      count++;
      pthread_mutex_unlock(&thr);
      pthread_cond_signal(&cond);
   }
   pthread_exit(0);
}
int main(int argc, char** argv){
   pthread_t thread1;
   pthread_t thread2;
   pthread_mutex_init(&thr, 0);
   pthread_cond_init(&cond, 0);
   pthread_create(&thread1, 0, &even, NULL);
   pthread_create(&thread2, 0, &odd, NULL);
   pthread_join(thread1, 0);
   pthread_join(thread2, 0);
   pthread_mutex_destroy(&thr);
   pthread_cond_destroy(&cond);
   return 0;
}
