/* this example shows how unnamed pipes may be used 
	https://www.ibm.com/docs/en/zos/2.4.0?topic=io-using-unnamed-pipes 
*/
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

int main() {
	int ret_val;
	int pfd[2];
	char buff[32];
	char string1[]="Hallo zusammen :-)";

	ret_val = pipe(pfd);                 /* Create pipe */
	if (ret_val != 0) {             /* Test for success */
	  printf("Unable to create a pipe; errno=%d\n",errno);
	  exit(1);                         /* Print error message and exit */
	}
	if (fork() == 0) {
 	  /* child program */
 	  close(pfd[0]); /* close the read end */
 	  printf("\n\tChild is writing to pipe:\t %s \n", string1);
 	  ret_val = write(pfd[1], string1, strlen(string1)+1); /*Write to pipe*/
 	  if (ret_val != strlen(string1)+1) {
 	     printf("Write did not return expected value\n");
 	     exit(2);                       /* Print error message and exit */
 	  }
	}	
	else {
	   /* parent program */
	   close(pfd[1]); /* close the write end of pipe */
	   ret_val = read(pfd[0],buff,strlen(string1)+1); /* Read from pipe */
	   if (ret_val != strlen(string1)+1) {
	      printf("Read did not return expected value\n");
	      exit(3);                       /* Print error message and exit */
	   }
	   printf("Parent got from the child program:\t %s \n",buff);
	}
	exit(0);
}
