// https://www.geeksforgeeks.org/signals-c-set-2/
// more info: https://faculty.cs.niu.edu/~hutchins/csci480/signals.htm
// C program to implement sighup(), sigint()
// and sigquit() signal functions
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

// function declaration
void sighup();
void sigint();
void sigquit();

// driver code
int main(int argc, char **argv){
	pid_t pid;

	/* get child process */
	pid = fork();
	if (pid < 0) {
		perror("fork");
		exit(1);
	} else if (pid == 0) { /* child */
		signal(SIGHUP, sighup);
		signal(SIGINT, sigint);
		signal(SIGQUIT, sigquit);
		//return 0;
		for (;;); /* loop for ever */
	}else /* parent */
	{ /* pid hold id of child */
		sleep(3); /* pause for 3 secs */
		printf("\nPARENT: sending SIGHUP\n\n");
		kill(pid, SIGHUP);

		sleep(3); /* pause for 3 secs */
		printf("\nPARENT: sending SIGINT\n\n");
		kill(pid, SIGINT);

		sleep(3); /* pause for 3 secs */
		printf("\nPARENT: sending SIGQUIT\n\n");
		kill(pid, SIGQUIT);
		sleep(3);
		exit(0);
	}
}

// sighup() function definition
void sighup(){
	//signal(SIGHUP, SIG_DFL); /* set signal to default */
	printf("CHILD: I have received a SIGHUP\n");
}

// sigint() function definition
void sigint(){
	signal(SIGINT, SIG_DFL);   /* set signal to defaul */
	printf("CHILD: I have received a SIGINT\n");
}

// sigquit() function definition
void sigquit(){
	printf("My DADDY has Killed me!!!\n");
	exit(0);
}
