#ifndef __SWAPPER_H__
#define __SWAPPER_H__

#define NUMBER_PHYSICAL_FRAMES 4
#define NUMBER_VIRTUAL_PAGES 5

#define R_BIT       1
#define M_BIT       2
#define PRESENT_BIT 3


#define READ_ACCESS 1
#define WRITE_ACCESS 2

#define SET_BIT(bitfield, bit)    bitfield |= (1U << bit)
#define IS_BIT_SET(bitfield, bit) (bitfield &  (1U << bit))
#define CLEAR_BIT(bitfield, bit)  bitfield &= ~(1U << bit)


struct virtual_page_entry {
	int page_number;
	struct physical_frame_entry* mapped_physical_frame;
	unsigned bits;
};

struct physical_frame_entry {
	int physical_frame_number;
	struct virtual_page_entry* virtual_page;
};

// Defines an memory access that consists of a virtual page that is accessed
// and an access method (read or write) to the memory page.
struct page_access {
	int virtual_page_number;
	int access;
};

#endif
