#include "swapper.h"
#include "swap_helpers.h"

#include <string.h>
#include <stdio.h>

extern struct virtual_page_entry virtual_page_table[NUMBER_VIRTUAL_PAGES];
extern struct physical_frame_entry physical_frames[NUMBER_PHYSICAL_FRAMES];

void init_structs() {
	memset(physical_frames, 0, sizeof(physical_frames));
	for (int i = 0; i != NUMBER_PHYSICAL_FRAMES; ++i) {
		physical_frames[i].physical_frame_number = i;
	}

	memset(virtual_page_table, 0, sizeof(virtual_page_table));
	for (int i = 0; i != NUMBER_VIRTUAL_PAGES; ++i) {
		virtual_page_table[i].page_number = i;	
	}
}

void print_table_header() {
	printf("\t | \tSeitenrahmen\n");
	printf("Zugriff  |");
	for (int i = 0; i != NUMBER_PHYSICAL_FRAMES; ++i) {
		printf("\t  %2i\t", i);
	}
	printf("\n---------|");
	for (int i = 0; i != NUMBER_PHYSICAL_FRAMES; ++i) {
		printf("----------------");
	}
	printf("\n");
}

void print_page_assignment(struct page_access last_page_access) {
	char access_char = last_page_access.access==READ_ACCESS?'l':'s';
	printf("  %3u %c  |", last_page_access.virtual_page_number, access_char);
	for (int i = 0; i != NUMBER_PHYSICAL_FRAMES; ++i) {
		struct virtual_page_entry* page_entry = physical_frames[i].virtual_page;
		if (page_entry == NULL) {
			printf("\t   - \t");
			continue;
		}
		printf("\t%2i %c %c  ", page_entry->page_number, 
				       IS_BIT_SET(page_entry->bits, R_BIT)?'r':' ',
				       IS_BIT_SET(page_entry->bits, M_BIT)?'m':' ');
	}
	printf("\n");
}


